#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#include "jsocket.h"

#define BUF_SIZE 1024
 
int main() {
   int s;
   int rc;
   int cnt, cnt2;
   char buf[BUF_SIZE];
 
   s = j_socket();
 
   rc= j_connect(s, "localhost", 1818);
   if (rc<0) {
	perror("connect");
	exit(1);
   }
 
   while ((cnt=read(0, buf, BUF_SIZE)) > 0) {
	if(write(s, buf, cnt) != cnt) {
	   perror("write");
	   exit(1);
	}
	while(cnt > 0) {
           cnt2=read(s, buf, BUF_SIZE);
           if (cnt2<=0) {
             if (cnt2==0)
               fprintf(stderr, "El socket fue cerrado por el servidor\n");
             else
               perror("read");
             return 1;
           }
	   write(1, "echo: ", 6);
           write(1, buf, cnt2);
	   cnt -= cnt2;
	}
   }
 
   return 0;
}
